package _VisualDVM.Passes.All;
import Common.Utils.Utils_;
import Common.Visual.UI_;
import _VisualDVM.Current;
import _VisualDVM.Global;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.Passes.Server.TestingSystemPass;
import _VisualDVM.Repository.Server.ServerCode;
import _VisualDVM.Repository.Server.ServerExchangeUnit_2021;
import _VisualDVM.TestingSystem.Common.Test.Test;
public class DownloadTest extends TestingSystemPass<Test> {
    @Override
    public String getIconPath() {
        return "/icons/DownloadBugReport.png";
    }
    @Override
    public String getButtonText() {
        return "";
    }
    @Override
    protected boolean canStart(Object... args) throws Exception {
        if (Global.mainModule.getAccount().CheckRegistered(Log) && Global.mainModule.Check(Log, Current.Test)) {
            target = Global.mainModule.getTest();
            return true;
        }
        return false;
    }
    @Override
    protected void performPreparation() throws Exception {
        Global.mainModule.getPass(PassCode.CloseCurrentProject).Do();
        Global.mainModule.set(Current.Root, null); //чтобы гарантированно не существовало корня.
        Utils_.forceDeleteWithCheck(target.getArchive());
        Utils_.forceDeleteWithCheck(target.getHomePath());
    }
    @Override
    protected void ServerAction() throws Exception {
        Command(new ServerExchangeUnit_2021(ServerCode.DownloadTest, String.valueOf(target.id)));
        response.Unpack(target.getArchive());
    }
    @Override
    protected boolean validate() {
        return target.getArchive().exists();
    }
    @Override
    protected void performDone() throws Exception {
        super.performDone();
        if (Global.mainModule.getPass(PassCode.UnzipFolderPass).Do(
                target.getArchive().getAbsolutePath(),
                Global.visualiser.getWorkspace().getAbsolutePath(), false
        ))
            if (UI_.Question("Тестовый проект успешно загружен под именем\n" +
                    Utils_.Brackets(target.getHomePath().getName()) +
                    "\nОткрыть его"))
                Global.mainModule.getPass(PassCode.OpenCurrentProject).Do(target.getHomePath());
    }
}


